#include<bits/stdc++.h>
using namespace std;
const int mod=1e9+7;
int n,m;
long long ans=0;
long long f(int n){
	long long s=0;
	for(int i=1;i<=n;i++){
		s+=n-i+1;
		s%=mod;
	}
}
int main(){
	freopen("barrack.in","r",stdin);
	freopen("barrack.out","w",stdout);
	scanf("%d%d",&n,&m);
	for(int i=1;i<=m;i++){
		int u,v;
		scanf("%d%d",&u,&v);
	}
	printf("%d\n",(f(n)+(1<<m))%mod);
	return 0;
}